// FullAccess
resource "azurerm_role_definition" "logic_apps_fullaccess_definition" {
  name              = "logic-apps-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Logic/register/action",
      "Microsoft.Logic/operations/read",
      "Microsoft.Logic/locations/workflows/validate/action",
      "Microsoft.Logic/locations/workflows/recommendOperationGroups/action",
      "Microsoft.Logic/workflows/read",
      "Microsoft.Logic/workflows/write",
      "Microsoft.Logic/workflows/delete",
      "Microsoft.Logic/workflows/run/action",
      "Microsoft.Logic/workflows/disable/action",
      "Microsoft.Logic/workflows/enable/action",
      "Microsoft.Logic/workflows/suspend/action",
      "Microsoft.Logic/workflows/validate/action",
      "Microsoft.Logic/workflows/move/action",
      "Microsoft.Logic/workflows/listSwagger/action",
      "Microsoft.Logic/workflows/regenerateAccessKey/action",
      "Microsoft.Logic/workflows/listCallbackUrl/action",
      "Microsoft.Logic/workflows/versions/read",
      "Microsoft.Logic/workflows/versions/triggers/listCallbackUrl/action",
      "Microsoft.Logic/workflows/accessKeys/read",
      "Microsoft.Logic/workflows/accessKeys/write",
      "Microsoft.Logic/workflows/accessKeys/delete",
      "Microsoft.Logic/workflows/accessKeys/list/action",
      "Microsoft.Logic/workflows/accessKeys/regenerate/action",
      "Microsoft.Logic/workflows/triggers/read",
      "Microsoft.Logic/workflows/triggers/run/action",
      "Microsoft.Logic/workflows/triggers/reset/action",
      "Microsoft.Logic/workflows/triggers/setState/action",
      "Microsoft.Logic/workflows/triggers/listCallbackUrl/action",
      "Microsoft.Logic/workflows/triggers/histories/read",
      "Microsoft.Logic/workflows/triggers/histories/resubmit/action",
      "Microsoft.Logic/workflows/runs/read",
      "Microsoft.Logic/workflows/runs/delete",
      "Microsoft.Logic/workflows/runs/cancel/action",
      "Microsoft.Logic/workflows/runs/operations/read",
      "Microsoft.Logic/workflows/runs/actions/read",
      "Microsoft.Logic/workflows/runs/actions/listExpressionTraces/action",
      "Microsoft.Logic/workflows/runs/actions/repetitions/read",
      "Microsoft.Logic/workflows/runs/actions/repetitions/listExpressionTraces/action",
      "Microsoft.Logic/workflows/runs/actions/scoperepetitions/read",
      "Microsoft.Logic/integrationAccounts/read",
      "Microsoft.Logic/integrationAccounts/write",
      "Microsoft.Logic/integrationAccounts/delete",
      "Microsoft.Logic/integrationAccounts/regenerateAccessKey/action",
      "Microsoft.Logic/integrationAccounts/listCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/listKeyVaultKeys/action",
      "Microsoft.Logic/integrationAccounts/logTrackingEvents/action",
      "Microsoft.Logic/integrationAccounts/join/action",
      "Microsoft.Logic/integrationAccounts/partners/read",
      "Microsoft.Logic/integrationAccounts/partners/write",
      "Microsoft.Logic/integrationAccounts/partners/delete",
      "Microsoft.Logic/integrationAccounts/partners/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/agreements/read",
      "Microsoft.Logic/integrationAccounts/agreements/write",
      "Microsoft.Logic/integrationAccounts/agreements/delete",
      "Microsoft.Logic/integrationAccounts/agreements/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/certificates/read",
      "Microsoft.Logic/integrationAccounts/certificates/write",
      "Microsoft.Logic/integrationAccounts/certificates/delete",
      "Microsoft.Logic/integrationAccounts/schemas/read",
      "Microsoft.Logic/integrationAccounts/schemas/write",
      "Microsoft.Logic/integrationAccounts/schemas/delete",
      "Microsoft.Logic/integrationAccounts/schemas/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/maps/read",
      "Microsoft.Logic/integrationAccounts/maps/write",
      "Microsoft.Logic/integrationAccounts/maps/delete",
      "Microsoft.Logic/integrationAccounts/maps/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/assemblies/read",
      "Microsoft.Logic/integrationAccounts/assemblies/write",
      "Microsoft.Logic/integrationAccounts/assemblies/delete",
      "Microsoft.Logic/integrationAccounts/assemblies/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/batchConfigurations/read",
      "Microsoft.Logic/integrationAccounts/batchConfigurations/write",
      "Microsoft.Logic/integrationAccounts/batchConfigurations/delete",
      "Microsoft.Logic/integrationAccounts/sessions/read",
      "Microsoft.Logic/integrationAccounts/sessions/write",
      "Microsoft.Logic/integrationAccounts/sessions/delete",
      "Microsoft.Logic/workflows/runs/actions/requestHistories/read",
      "Microsoft.Logic/workflows/runs/actions/repetitions/requestHistories/read",
      "Microsoft.Logic/integrationServiceEnvironments/read",
      "Microsoft.Logic/integrationServiceEnvironments/write",
      "Microsoft.Logic/integrationServiceEnvironments/delete",
      "Microsoft.Logic/integrationServiceEnvironments/join/action",
      "Microsoft.Logic/integrationServiceEnvironments/managedApis/read",
      "Microsoft.Logic/integrationServiceEnvironments/managedApis/apiOperations/read",
      "Microsoft.Logic/integrationServiceEnvironments/operationStatuses/read",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "logic_apps_readonly_definition" {
  name              = "logic-apps-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Logic/operations/read",
      "Microsoft.Logic/workflows/read",
      "Microsoft.Logic/workflows/versions/read",
      "Microsoft.Logic/workflows/accessKeys/read",
      "Microsoft.Logic/workflows/triggers/read",
      "Microsoft.Logic/workflows/triggers/histories/read",
      "Microsoft.Logic/workflows/runs/read",
      "Microsoft.Logic/workflows/runs/operations/read",
      "Microsoft.Logic/workflows/runs/actions/read",
      "Microsoft.Logic/workflows/runs/actions/repetitions/read",
      "Microsoft.Logic/workflows/runs/actions/scoperepetitions/read",
      "Microsoft.Logic/integrationAccounts/read",
      "Microsoft.Logic/integrationAccounts/partners/read",
      "Microsoft.Logic/integrationAccounts/agreements/read",
      "Microsoft.Logic/integrationAccounts/certificates/read",
      "Microsoft.Logic/integrationAccounts/schemas/read",
      "Microsoft.Logic/integrationAccounts/maps/read",
      "Microsoft.Logic/integrationAccounts/assemblies/read",
      "Microsoft.Logic/integrationAccounts/batchConfigurations/read",
      "Microsoft.Logic/integrationAccounts/sessions/read",
      "Microsoft.Logic/workflows/runs/actions/requestHistories/read",
      "Microsoft.Logic/workflows/runs/actions/repetitions/requestHistories/read",
      "Microsoft.Logic/integrationServiceEnvironments/read",
      "Microsoft.Logic/integrationServiceEnvironments/managedApis/read",
      "Microsoft.Logic/integrationServiceEnvironments/managedApis/apiOperations/read",
      "Microsoft.Logic/integrationServiceEnvironments/operationStatuses/read",
    ]

    not_actions = [
      "Microsoft.Logic/register/action",
      "Microsoft.Logic/locations/workflows/validate/action",
      "Microsoft.Logic/locations/workflows/recommendOperationGroups/action",
      "Microsoft.Logic/workflows/write",
      "Microsoft.Logic/workflows/delete",
      "Microsoft.Logic/workflows/run/action",
      "Microsoft.Logic/workflows/disable/action",
      "Microsoft.Logic/workflows/enable/action",
      "Microsoft.Logic/workflows/suspend/action",
      "Microsoft.Logic/workflows/validate/action",
      "Microsoft.Logic/workflows/move/action",
      "Microsoft.Logic/workflows/listSwagger/action",
      "Microsoft.Logic/workflows/regenerateAccessKey/action",
      "Microsoft.Logic/workflows/listCallbackUrl/action",
      "Microsoft.Logic/workflows/versions/triggers/listCallbackUrl/action",
      "Microsoft.Logic/workflows/accessKeys/write",
      "Microsoft.Logic/workflows/accessKeys/delete",
      "Microsoft.Logic/workflows/accessKeys/list/action",
      "Microsoft.Logic/workflows/accessKeys/regenerate/action",
      "Microsoft.Logic/workflows/triggers/run/action",
      "Microsoft.Logic/workflows/triggers/reset/action",
      "Microsoft.Logic/workflows/triggers/setState/action",
      "Microsoft.Logic/workflows/triggers/listCallbackUrl/action",
      "Microsoft.Logic/workflows/triggers/histories/resubmit/action",
      "Microsoft.Logic/workflows/runs/delete",
      "Microsoft.Logic/workflows/runs/cancel/action",
      "Microsoft.Logic/workflows/runs/actions/listExpressionTraces/action",
      "Microsoft.Logic/workflows/runs/actions/repetitions/listExpressionTraces/action",
      "Microsoft.Logic/integrationAccounts/write",
      "Microsoft.Logic/integrationAccounts/delete",
      "Microsoft.Logic/integrationAccounts/regenerateAccessKey/action",
      "Microsoft.Logic/integrationAccounts/listCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/listKeyVaultKeys/action",
      "Microsoft.Logic/integrationAccounts/logTrackingEvents/action",
      "Microsoft.Logic/integrationAccounts/join/action",
      "Microsoft.Logic/integrationAccounts/partners/write",
      "Microsoft.Logic/integrationAccounts/partners/delete",
      "Microsoft.Logic/integrationAccounts/partners/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/agreements/write",
      "Microsoft.Logic/integrationAccounts/agreements/delete",
      "Microsoft.Logic/integrationAccounts/agreements/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/certificates/write",
      "Microsoft.Logic/integrationAccounts/certificates/delete",
      "Microsoft.Logic/integrationAccounts/schemas/write",
      "Microsoft.Logic/integrationAccounts/schemas/delete",
      "Microsoft.Logic/integrationAccounts/schemas/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/maps/write",
      "Microsoft.Logic/integrationAccounts/maps/delete",
      "Microsoft.Logic/integrationAccounts/maps/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/assemblies/write",
      "Microsoft.Logic/integrationAccounts/assemblies/delete",
      "Microsoft.Logic/integrationAccounts/assemblies/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/batchConfigurations/write",
      "Microsoft.Logic/integrationAccounts/batchConfigurations/delete",
      "Microsoft.Logic/integrationAccounts/sessions/write",
      "Microsoft.Logic/integrationAccounts/sessions/delete",
      "Microsoft.Logic/integrationServiceEnvironments/write",
      "Microsoft.Logic/integrationServiceEnvironments/delete",
      "Microsoft.Logic/integrationServiceEnvironments/join/action",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "logic_apps_noaccess_definition" {
  name              = "logic-apps-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.Logic/register/action",
      "Microsoft.Logic/operations/read",
      "Microsoft.Logic/locations/workflows/validate/action",
      "Microsoft.Logic/locations/workflows/recommendOperationGroups/action",
      "Microsoft.Logic/workflows/read",
      "Microsoft.Logic/workflows/write",
      "Microsoft.Logic/workflows/delete",
      "Microsoft.Logic/workflows/run/action",
      "Microsoft.Logic/workflows/disable/action",
      "Microsoft.Logic/workflows/enable/action",
      "Microsoft.Logic/workflows/suspend/action",
      "Microsoft.Logic/workflows/validate/action",
      "Microsoft.Logic/workflows/move/action",
      "Microsoft.Logic/workflows/listSwagger/action",
      "Microsoft.Logic/workflows/regenerateAccessKey/action",
      "Microsoft.Logic/workflows/listCallbackUrl/action",
      "Microsoft.Logic/workflows/versions/read",
      "Microsoft.Logic/workflows/versions/triggers/listCallbackUrl/action",
      "Microsoft.Logic/workflows/accessKeys/read",
      "Microsoft.Logic/workflows/accessKeys/write",
      "Microsoft.Logic/workflows/accessKeys/delete",
      "Microsoft.Logic/workflows/accessKeys/list/action",
      "Microsoft.Logic/workflows/accessKeys/regenerate/action",
      "Microsoft.Logic/workflows/triggers/read",
      "Microsoft.Logic/workflows/triggers/run/action",
      "Microsoft.Logic/workflows/triggers/reset/action",
      "Microsoft.Logic/workflows/triggers/setState/action",
      "Microsoft.Logic/workflows/triggers/listCallbackUrl/action",
      "Microsoft.Logic/workflows/triggers/histories/read",
      "Microsoft.Logic/workflows/triggers/histories/resubmit/action",
      "Microsoft.Logic/workflows/runs/read",
      "Microsoft.Logic/workflows/runs/delete",
      "Microsoft.Logic/workflows/runs/cancel/action",
      "Microsoft.Logic/workflows/runs/operations/read",
      "Microsoft.Logic/workflows/runs/actions/read",
      "Microsoft.Logic/workflows/runs/actions/listExpressionTraces/action",
      "Microsoft.Logic/workflows/runs/actions/repetitions/read",
      "Microsoft.Logic/workflows/runs/actions/repetitions/listExpressionTraces/action",
      "Microsoft.Logic/workflows/runs/actions/scoperepetitions/read",
      "Microsoft.Logic/integrationAccounts/read",
      "Microsoft.Logic/integrationAccounts/write",
      "Microsoft.Logic/integrationAccounts/delete",
      "Microsoft.Logic/integrationAccounts/regenerateAccessKey/action",
      "Microsoft.Logic/integrationAccounts/listCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/listKeyVaultKeys/action",
      "Microsoft.Logic/integrationAccounts/logTrackingEvents/action",
      "Microsoft.Logic/integrationAccounts/join/action",
      "Microsoft.Logic/integrationAccounts/partners/read",
      "Microsoft.Logic/integrationAccounts/partners/write",
      "Microsoft.Logic/integrationAccounts/partners/delete",
      "Microsoft.Logic/integrationAccounts/partners/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/agreements/read",
      "Microsoft.Logic/integrationAccounts/agreements/write",
      "Microsoft.Logic/integrationAccounts/agreements/delete",
      "Microsoft.Logic/integrationAccounts/agreements/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/certificates/read",
      "Microsoft.Logic/integrationAccounts/certificates/write",
      "Microsoft.Logic/integrationAccounts/certificates/delete",
      "Microsoft.Logic/integrationAccounts/schemas/read",
      "Microsoft.Logic/integrationAccounts/schemas/write",
      "Microsoft.Logic/integrationAccounts/schemas/delete",
      "Microsoft.Logic/integrationAccounts/schemas/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/maps/read",
      "Microsoft.Logic/integrationAccounts/maps/write",
      "Microsoft.Logic/integrationAccounts/maps/delete",
      "Microsoft.Logic/integrationAccounts/maps/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/assemblies/read",
      "Microsoft.Logic/integrationAccounts/assemblies/write",
      "Microsoft.Logic/integrationAccounts/assemblies/delete",
      "Microsoft.Logic/integrationAccounts/assemblies/listContentCallbackUrl/action",
      "Microsoft.Logic/integrationAccounts/batchConfigurations/read",
      "Microsoft.Logic/integrationAccounts/batchConfigurations/write",
      "Microsoft.Logic/integrationAccounts/batchConfigurations/delete",
      "Microsoft.Logic/integrationAccounts/sessions/read",
      "Microsoft.Logic/integrationAccounts/sessions/write",
      "Microsoft.Logic/integrationAccounts/sessions/delete",
      "Microsoft.Logic/workflows/runs/actions/requestHistories/read",
      "Microsoft.Logic/workflows/runs/actions/repetitions/requestHistories/read",
      "Microsoft.Logic/integrationServiceEnvironments/read",
      "Microsoft.Logic/integrationServiceEnvironments/write",
      "Microsoft.Logic/integrationServiceEnvironments/delete",
      "Microsoft.Logic/integrationServiceEnvironments/join/action",
      "Microsoft.Logic/integrationServiceEnvironments/managedApis/read",
      "Microsoft.Logic/integrationServiceEnvironments/managedApis/apiOperations/read",
      "Microsoft.Logic/integrationServiceEnvironments/operationStatuses/read",
    ]
  }
}
